# DXGfxLib.EnhancedMeshContainer Class Reference

We want to keep track of quite a lot of information that are not kept by MeshContainer. So we derive our own class from it and add members to keep track of every single information we need. These information are populated when loading a hierarchy from file by EnhancedAllocateHierarchy. More...

Collaboration diagram for DXGfxLib.EnhancedMeshContainer:

[legend]

List of all members.

## Public Attributes
Mesh | oriMesh = null
| The original mesh.
bool | hasSkin = false
| This property flags whether or not we have skinning information for this mesh.
Mesh | BlendedMesh
| The blended mesh to draw.
BoneCombination[] | BoneCombinations
| The bone combinations for this mesh. Each bone combination represents a mesh subset with the same attribute and bone combination, and can be drawn in a single drawing call.
int | numMaterials = 0
Microsoft.DirectX.Direct3D.Material[] | materials
| Materials for the blended mesh.
Texture[] | textures
| Textures for the blended mesh.
int | MaxFaceInfluences = 0
| Maximum number of influences effecting any single face in the skin mesh.
Matrix[] | BoneOffsetMatrices
| Bone offset matrices for all bones that affect this mesh. Stored here for fast lookup while drawing. Fetched from SkinInformation.GetBoneOffsetMatrix(matrixId).
EnhancedFrame[] | AffectingBones
| Bones (frames) that affect this mesh. Stored here for fast lookup while drawing. Fetched from Frame.Find(root, SkinInformation.GetBoneName(i)).
EffectInstance[] | EffectInstances
| In case our blended mesh needs effects for its rendering we would store them here.
AABBox | localBoundingBox
| It is interesting to calculate and keep a local bounding box for each container.

## Detailed Description

We want to keep track of quite a lot of information that are not kept by MeshContainer. So we derive our own class from it and add members to keep track of every single information we need. These information are populated when loading a hierarchy from file by EnhancedAllocateHierarchy.

Definition at line 61 of file ArticulatedModel.cs.

## Member Data Documentation

EnhancedFrame [] DXGfxLib.EnhancedMeshContainer.AffectingBones

Bones (frames) that affect this mesh. Stored here for fast lookup while drawing. Fetched from Frame.Find(root, SkinInformation.GetBoneName(i)).

Definition at line 110 of file ArticulatedModel.cs.

Mesh DXGfxLib.EnhancedMeshContainer::BlendedMesh

The blended mesh to draw.

Definition at line 76 of file ArticulatedModel.cs.

BoneCombination [] DXGfxLib.EnhancedMeshContainer.BoneCombinations

The bone combinations for this mesh. Each bone combination represents a mesh subset with the same attribute and bone combination, and can be drawn in a single drawing call.

Definition at line 82 of file ArticulatedModel.cs.

Matrix [] DXGfxLib.EnhancedMeshContainer.BoneOffsetMatrices

Bone offset matrices for all bones that affect this mesh. Stored here for fast lookup while drawing. Fetched from SkinInformation.GetBoneOffsetMatrix(matrixId).

Definition at line 104 of file ArticulatedModel.cs.

EffectInstance [] DXGfxLib.EnhancedMeshContainer.EffectInstances

In case our blended mesh needs effects for its rendering we would store them here.

Definition at line 115 of file ArticulatedModel.cs.

bool DXGfxLib.EnhancedMeshContainer::hasSkin = false

This property flags whether or not we have skinning information for this mesh.

Definition at line 71 of file ArticulatedModel.cs.

AABBox DXGfxLib.EnhancedMeshContainer::localBoundingBox

It is interesting to calculate and keep a local bounding box for each container.

Definition at line 120 of file ArticulatedModel.cs.

Microsoft.DirectX.Direct3D.Material [] DXGfxLib.EnhancedMeshContainer.materials

Materials for the blended mesh.

Definition at line 88 of file ArticulatedModel.cs.

int DXGfxLib.EnhancedMeshContainer::MaxFaceInfluences = 0

Maximum number of influences effecting any single face in the skin mesh.

Definition at line 98 of file ArticulatedModel.cs.

int DXGfxLib.EnhancedMeshContainer::numMaterials = 0

Definition at line 84 of file ArticulatedModel.cs.

Mesh DXGfxLib.EnhancedMeshContainer::oriMesh = null

The original mesh.

Definition at line 66 of file ArticulatedModel.cs.

Texture [] DXGfxLib.EnhancedMeshContainer.textures

Textures for the blended mesh.

Definition at line 93 of file ArticulatedModel.cs.

The documentation for this class was generated from the following files:

- D:/guillaume/guillara/3D/DXGfx/Backup/DXGfxLib/ArticulatedModel.cs
- D:/guillaume/guillara/3D/DXGfx/DXGfxLib/ArticulatedModel.cs